Package: org.codehaus.groovy.transform

## [Java] Class TupleConstructorASTStubber

- org.codehaus.groovy.transform.TupleConstructorASTStubber

-     @GroovyASTTransformation(phase = CompilePhase.CONVERSION)
      public class TupleConstructorASTStubber
      extends AbstractASTTransformation

  Adds a placeholder tuple-style constructor surface for TupleConstructor classes during joint compilation. The set of parameters honoured — `includes`, `excludes`, `allNames`, `includeProperties`, `includeFields`, `includeSuperProperties`, `includeSuperFields`, `allProperties` — comes from TupleConstructorASTTransformation.selectTupleProperties, the same helper the full transform uses, so the joint-compilation stub's constructor signature is a strict subset of the runtime's.

  When `defaults != false` (the default), the runtime exposes the full prefix-overload chain via `Verifier`. The stubber mirrors that chain so Java consumers can drop trailing arguments. When `defaults = false` only the maximal-arg constructor is emitted, matching the runtime.

  Trait-injected and same-unit super-class members added by another transform are not visible at CONVERSION; the stubber may therefore see a smaller surface than the runtime does for those configurations. The resulting stub remains a strict subset.

  Since:
    6.0.0

- - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class AbstractASTTransformation` | `RETENTION_CLASSNODE, sourceUnit`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public void` | `visit(ASTNode[] nodes, SourceUnit source)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class AbstractASTTransformation` | `addError, checkIncludeExcludeUndefinedAware, checkIncludeExcludeUndefinedAware, checkNotInterface, checkPropertyList, checkPropertyList, checkPropertyList, copyAnnotatedNodeAnnotations, copyAnnotatedNodeAnnotations, deemedInternal, deemedInternalName, getAnnotationName, getMemberClassList, getMemberClassValue, getMemberClassValue, getMemberIntValue, getMemberStringList, getMemberStringValue, getMemberStringValue, getMemberValue, hasAnnotation, init, markAsInternal, memberHasValue, shouldSkip, shouldSkip, shouldSkip, shouldSkipOnDescriptorUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, tokenize`

- - ### Method Detail

    - #### public void visit(ASTNode[] nodes, SourceUnit source)